Index: trunk/calendar/inc/class.boicalendar.inc.php
===================================================================
--- trunk/calendar/inc/class.boicalendar.inc.php	(revision 3736)
+++ trunk/calendar/inc/class.boicalendar.inc.php	(revision 5132)
@@ -2083,479 +1925,401 @@
 					}
 				}
-				$this->debug('DATETIME : '._debug_array($dtime,False));
+			$this->debug('DATETIME : ' . _debug_array($dtime, False));
 				return $dtime;
 			}
-			elseif(is_array($var))
-			{
-				return date('Ymd\THis\Z',mktime($var['hour'],$var['min'],$var['sec'],$var['month'],$var['mday'],$var['year']));
-			}
-			else
-			{
+		elseif (is_array($var)) {
+			return date('Ymd\THis\Z', mktime($var['hour'], $var['min'], $var['sec'], $var['month'], $var['mday'], $var['year']));
+		} else {
 				return $var;
 			}
 		}
 
-		function switch_encoding($var)
-		{
-			if(is_string($var))
-			{
-				switch($var)
-				{
-					case '8BIT':
+	function switch_encoding($var) {
+		if (is_string($var)) {
+			switch ($var) {
+				case '8BIT' :
 						return _8BIT;
 						break;
-					case 'BASE64':
+				case 'BASE64' :
 						return _BASE64;
 						break;
-					default:
+				default :
 						return OTHER;
 						break;
 				}
 			}
-			elseif(is_int($var))
-			{
-				switch($var)
-				{
-					case _8BIT:
+		elseif (is_int($var)) {
+			switch ($var) {
+				case _8BIT :
 						return '8BIT';
 						break;
-					case _BASE64:
+				case _BASE64 :
 						return 'BASE64';
 						break;
-					case OTHER:
+				case OTHER :
 						return 'OTHER';
 						break;
 				}
-			}
-			else
-			{
+		} else {
 				return $var;
 			}
 		}
 
-		function switch_fbtype($var)
-		{
-			if(is_string($var))
-			{
-				switch($var)
-				{
-					case 'FREE':
+	function switch_fbtype($var) {
+		if (is_string($var)) {
+			switch ($var) {
+				case 'FREE' :
 						return FREE;
 						break;
-					case 'BUSY':
+				case 'BUSY' :
 						return BUSY;
 						break;
-					case 'BUSY-UNAVAILABLE':
+				case 'BUSY-UNAVAILABLE' :
 						return BUSY_UNAVAILABLE;
 						break;
-					case 'BUSY-TENTATIVE':
+				case 'BUSY-TENTATIVE' :
 						return BUSY_TENTATIVE;
 						break;
-					default:
+				default :
 						return OTHER;
 						break;
 				}
 			}
-			elseif(is_int($var))
-			{
-				switch($var)
-				{
-					case FREE:
+		elseif (is_int($var)) {
+			switch ($var) {
+				case FREE :
 						return 'FREE';
 						break;
-					case BUSY:
+				case BUSY :
 						return 'BUSY';
 						break;
-					case BUSY_UNAVAILABLE:
+				case BUSY_UNAVAILABLE :
 						return 'BUSY-UNAVAILABLE';
 						break;
-					case BUSY_TENTATIVE:
+				case BUSY_TENTATIVE :
 						return 'BUSY-TENTATIVE';
 						break;
-					default:
+				default :
 						return 'OTHER';
 						break;
 				}
-			}
-			else
-			{
+		} else {
 				return $var;
 			}
 		}
 
-		function switch_freq($var)
-		{
-			if(is_string($var))
-			{
-				switch($var)
-				{
-					case 'SECONDLY':
+	function switch_freq($var) {
+		if (is_string($var)) {
+			switch ($var) {
+				case 'SECONDLY' :
 						return SECONDLY;
 						break;
-					case 'MINUTELY':
+				case 'MINUTELY' :
 						return MINUTELY;
 						break;
-					case 'HOURLY':
+				case 'HOURLY' :
 						return HOURLY;
 						break;
-					case 'DAILY':
+				case 'DAILY' :
 						return DAILY;
 						break;
-					case 'WEEKLY':
+				case 'WEEKLY' :
 						return WEEKLY;
 						break;
-					case 'MONTHLY':
+				case 'MONTHLY' :
 						return MONTHLY;
 						break;
-					case 'YEARLY':
+				case 'YEARLY' :
 						return YEARLY;
 						break;
 				}
 			}
-			elseif(is_int($var))
-			{
-				switch($var)
-				{
-					case SECONDLY:
+		elseif (is_int($var)) {
+			switch ($var) {
+				case SECONDLY :
 						return 'SECONDLY';
 						break;
-					case MINUTELY:
+				case MINUTELY :
 						return 'MINUTELY';
 						break;
-					case HOURLY:
+				case HOURLY :
 						return 'HOURLY';
 						break;
-					case DAILY:
+				case DAILY :
 						return 'DAILY';
 						break;
-					case WEEKLY:
+				case WEEKLY :
 						return 'WEEKLY';
 						break;
-					case MONTHLY:
+				case MONTHLY :
 						return 'MONTHLY';
 						break;
-					case YEARLY:
+				case YEARLY :
 						return 'YEARLY';
 						break;
 				}
-			}
-			else
-			{
+		} else {
 				return $var;
 			}
 		}
 
-		function switch_mailto($var)
-		{
-			if(is_string($var))
-			{
-				$var = str_replace(array("\r\n", "\n", "\r"), "", $var);
-				if(strpos(' '.$var,':'))
-				{
-					$parts = explode(':',$var);
+	function switch_mailto($var) {
+		if (is_string($var)) {
+			$var = str_replace(array (
+				"\r\n",
+				"\n",
+				"\r"
+			), "", $var);
+			if (strpos(' ' . $var, ':')) {
+				$parts = explode(':', $var);
 					$var = $parts[1];
 				}
 
-				$parts = explode('@',$var);
+			$parts = explode('@', $var);
 				//$this->debug("Count of mailto parts : ".count($parts));
-				if(count($parts) == 2)
-				{
+			if (count($parts) == 2) {
 					//$this->debug("Splitting ".$parts[0]." @ ".$parts[1]);
-					$temp_address = Array();
+				$temp_address = Array ();
 					$temp_address['user'] = $parts[0];
 					$temp_address['host'] = $parts[1];
 					return $temp_address;
-				}
-				else
-				{
+			} else {
 					return False;
 				}
 			}
-			elseif(is_array($var))
-			{
-//				return 'MAILTO:'.$var['user'].'@'.$var['host'];
-				return $var['user'].'@'.$var['host'];
-			}
-		}
-
-		function switch_partstat($var)
-		{
-			$this->debug('PARTSTAT = '.$var);
-			if(is_string($var))
-			{
-				switch($var)
-				{
-					case 'NEEDS-ACTION':
+		elseif (is_array($var)) {
+			//				return 'MAILTO:'.$var['user'].'@'.$var['host'];
+			return $var['user'] . '@' . $var['host'];
+			}
+		}
+
+	function switch_partstat($var) {
+		$this->debug('PARTSTAT = ' . $var);
+		if (is_string($var)) {
+			switch ($var) {
+				case 'NEEDS-ACTION' :
 						return 0; // NEEDS_ACTION;
 						break;
-					case 'ACCEPTED':
+				case 'ACCEPTED' :
 						return 1; // ACCEPTED;
 						break;
-					case 'DECLINED':
+				case 'DECLINED' :
 						return 2; // DECLINED;
 						break;
-					case 'TENTATIVE':
+				case 'TENTATIVE' :
 						return 3; // TENTATIVE;
 						break;
-					case 'DELEGATED':
+				case 'DELEGATED' :
 						return 4; // DELEGATED;
 						break;
-					case 'COMPLETED':
+				case 'COMPLETED' :
 						return 5; // COMPLETED;
 						break;
-					case 'IN-PROCESS':
+				case 'IN-PROCESS' :
 						return 6; // IN_PROCESS;
 						break;
-					default:
+				default :
 						return 99; // OTHER;
 						break;
 				}
 			}
-			elseif(is_int($var))
-			{
-				switch((int)$var)
-				{
-					case 0: // NEEDS_ACTION:
+		elseif (is_int($var)) {
+			switch ((int) $var) {
+				case 0 : // NEEDS_ACTION:
 						return 'NEEDS-ACTION';
 						break;
-					case 1: //  ACCEPTED:
+				case 1 : //  ACCEPTED:
 						return 'ACCEPTED';
 						break;
-					case 2: // DECLINED:
+				case 2 : // DECLINED:
 						return 'DECLINED';
 						break;
-					case 3: // TENTATIVE:
+				case 3 : // TENTATIVE:
 						return 'TENTATIVE';
 						break;
-					case 4: // DELEGATED:
+				case 4 : // DELEGATED:
 						return 'DELEGATED';
 						break;
-					case 5: // COMPLETED:
+				case 5 : // COMPLETED:
 						return 'COMPLETED';
 						break;
-					case 6: // IN_PROCESS:
+				case 6 : // IN_PROCESS:
 						return 'IN-PROCESS';
 						break;
-					default:
+				default :
 						return 'X-OTHER';
 						break;
 				}
-			}
-			else
-			{
+		} else {
 				return $var;
 			}
 		}
 
-		function switch_range($var)
-		{
-			if(is_string($var))
-			{
-				switch($var)
-				{
-					case 'THISANDPRIOR':
+	function switch_range($var) {
+		if (is_string($var)) {
+			switch ($var) {
+				case 'THISANDPRIOR' :
 						return THISANDPRIOR;
 						break;
-					case 'THISANDFUTURE':
+				case 'THISANDFUTURE' :
 						return THISANDFUTURE;
 						break;
 				}
 			}
-			elseif(is_int($var))
-			{
-				switch($var)
-				{
-					case THISANDPRIOR:
+		elseif (is_int($var)) {
+			switch ($var) {
+				case THISANDPRIOR :
 						return 'THISANDPRIOR';
 						break;
-					case THISANDFUTURE:
+				case THISANDFUTURE :
 						return 'THISANDFUTURE';
 						break;
 				}
-			}
-			else
-			{
+		} else {
 				return $var;
 			}
 		}
 
-		function switch_related($var)
-		{
-			if(is_string($var))
-			{
-				switch($var)
-				{
-					case 'START':
+	function switch_related($var) {
+		if (is_string($var)) {
+			switch ($var) {
+				case 'START' :
 						return START;
 						break;
-					case 'END':
+				case 'END' :
 						return END;
 						break;
 				}
 			}
-			elseif(is_int($var))
-			{
-				switch($var)
-				{
-					case START:
+		elseif (is_int($var)) {
+			switch ($var) {
+				case START :
 						return 'START';
 						break;
-					case END:
+				case END :
 						return 'END';
 						break;
 				}
-			}
-			else
-			{
+		} else {
 				return $var;
 			}
 		}
 
-		function switch_reltype($var)
-		{
-			if(is_string($var))
-			{
-				switch($var)
-				{
-					case 'PARENT':
+	function switch_reltype($var) {
+		if (is_string($var)) {
+			switch ($var) {
+				case 'PARENT' :
 						return PARENT;
 						break;
-					case 'CHILD':
+				case 'CHILD' :
 						return CHILD;
 						break;
-					case 'SIBLING':
+				case 'SIBLING' :
 						return SIBLING;
 						break;
 				}
 			}
-			elseif(is_int($var))
-			{
-				switch($var)
-				{
-					case PARENT:
+		elseif (is_int($var)) {
+			switch ($var) {
+				case PARENT :
 						return 'PARENT';
 						break;
-					case CHILD:
+				case CHILD :
 						return 'CHILD';
 						break;
-					case SIBLING:
+				case SIBLING :
 						return 'SIBLING';
 						break;
 				}
-			}
-			else
-			{
+		} else {
+			return $var;
+			}
+		}
+
+	function switch_role($var) {
+		if (is_string($var)) {
+			switch ($var) {
+				case 'NONE' :
+						return NONE;
+						break;
+				case 'CHAIR' :
+						return CHAIR;
+						break;
+				case 'REQ-PARTICIPANT' :
+						return REQ_PARTICIPANT;
+						break;
+				case 'OPT-PARTICIPANT' :
+						return OPT_PARTICIPANT;
+						break;
+				case 'NON-PARTICIPANT' :
+						return NON_PARTICIPANT;
+						break;
+				}
+			}
+		elseif (is_int($var)) {
+			switch ($var) {
+				case NONE :
+						return 'NONE';
+						break;
+				case CHAIR :
+						return 'CHAIR';
+						break;
+				case REQ_PARTICIPANT :
+						return 'REQ-PARTICIPANT';
+						break;
+				case OPT_PARTICIPANT :
+						return 'OPT-PARTICIPANT';
+						break;
+				case NON_PARTICIPANT :
+						return 'NON-PARTICIPANT';
+						break;
+				}
+		} else {
 				return $var;
 			}
 		}
 
-		function switch_role($var)
-		{
-			if(is_string($var))
-			{
-				switch($var)
-				{
-					case 'NONE':
-						return NONE;
-						break;
-					case 'CHAIR':
-						return CHAIR;
-						break;
-					case 'REQ-PARTICIPANT':
-						return REQ_PARTICIPANT;
-						break;
-					case 'OPT-PARTICIPANT':
-						return OPT_PARTICIPANT;
-						break;
-					case 'NON-PARTICIPANT':
-						return NON_PARTICIPANT;
-						break;
-				}
-			}
-			elseif(is_int($var))
-			{
-				switch($var)
-				{
-					case NONE:
-						return 'NONE';
-						break;
-					case CHAIR:
-						return 'CHAIR';
-						break;
-					case REQ_PARTICIPANT:
-						return 'REQ-PARTICIPANT';
-						break;
-					case OPT_PARTICIPANT:
-						return 'OPT-PARTICIPANT';
-						break;
-					case NON_PARTICIPANT:
-						return 'NON-PARTICIPANT';
-						break;
-				}
-			}
-			else
-			{
+	function switch_rsvp($var) {
+		if (is_string($var)) {
+			if ($var == 'TRUE') {
+					return 1;
+				}
+			elseif ($var == 'FALSE') {
+					return 0;
+				}
+			}
+		elseif (is_int($var) || $var == False) {
+			if ($var == 1) {
+					return 'TRUE';
+				}
+			elseif ($var == 0) {
+					return 'FALSE';
+				}
+		} else {
 				return $var;
 			}
 		}
 
-		function switch_rsvp($var)
-		{
-			if(is_string($var))
-			{
-				if($var == 'TRUE')
-				{
-					return 1;
-				}
-				elseif($var == 'FALSE')
-				{
-					return 0;
-				}
-			}
-			elseif(is_int($var) || $var == False)
-			{
-				if($var == 1)
-				{
-					return 'TRUE';
-				}
-				elseif($var == 0)
-				{
-					return 'FALSE';
-				}
-			}
-			else
-			{
-				return $var;
-			}
-		}
-
-		function switch_transp($var)
-		{
-			if(is_string($var))
-			{
-				switch($var)
-				{
-					case 'TRANSPARENT':
+	function switch_transp($var) {
+		if (is_string($var)) {
+			switch ($var) {
+				case 'TRANSPARENT' :
 						return TRANSPARENT;
 						break;
-					case 'OPAQUE':
+				case 'OPAQUE' :
 						return OPAQUE;
 						break;
 				}
 			}
-			elseif(is_int($var))
-			{
-				switch($var)
-				{
-					case TRANSPARENT:
+		elseif (is_int($var)) {
+			switch ($var) {
+				case TRANSPARENT :
 						return 'TRANSPARENT';
 						break;
-					case OPAQUE:
+				case OPAQUE :
 						return 'OPAQUE';
 						break;
 				}
-			}
-			else
-			{
+		} else {
 				return $var;
 			}
@@ -2566,6 +2330,5 @@
 		 */
 
-		function parse($ical_text)
-		{
+	function parse($ical_text) {
 			$begin_regexp = '^';
 			$semi_colon_regexp = '[\;\:]';
@@ -2573,70 +2336,57 @@
 			$catch_all_regexp = '(.*)';
 			$end_regexp = '$';
-			$property_regexp = $begin_regexp.'([A-Z\-]*)'.$semi_colon_regexp.$catch_all_regexp.$end_regexp;
-			$param_regexp = $begin_regexp.$catch_all_regexp.':'.$catch_all_regexp.$end_regexp;
+		$property_regexp = $begin_regexp . '([A-Z\-]*)' . $semi_colon_regexp . $catch_all_regexp . $end_regexp;
+		$param_regexp = $begin_regexp . $catch_all_regexp . ':' . $catch_all_regexp . $end_regexp;
 
 			$mode = 'none';
 			$text = $this->read_line_unfold($ical_text);
-			while($text)
-			{
-//				if(strlen($ical_text[$i]) > 75)
-//				{
-//					continue;
-//				}
-
-				ereg($property_regexp,$text,$temp);
+		while ($text) {
+			//				if(strlen($ical_text[$i]) > 75)
+			//				{
+			//					continue;
+			//				}
+
+			ereg($property_regexp, $text, $temp);
 				//$this->debug ('Majortype dump: '._debug_array($temp, false) );
-				$majortype = str_replace('-','_',strtolower($temp[1]));
+			$majortype = str_replace('-', '_', strtolower($temp[1]));
 				$value = chop($temp[2]);
-
-				if($mode != 'none' && ($majortype != 'begin' && $majortype != 'end'))
-				{
+			if ($mode != 'none' && ($majortype != 'begin' && $majortype != 'end')) {
 					//$this->debug('PARSE:MAJORTYPE : '.$majortype);
-					if(isset($this->property[$majortype]))
-					{
-						$state = @$this->property[$majortype]["$mode"]['state'];
-						$type = @$this->property[$majortype]['type'];
-						$multiples = @$this->property[$majortype]["$mode"]['multiples'];
-						$do_to_text = @$this->property[$majortype]['to_text'];
-					}
-					elseif(substr($majortype,0,2) == 'x_')
-					{
+				if (isset ($this->property[$majortype])) {
+					$state = @ $this->property[$majortype]["$mode"]['state'];
+					$type = @ $this->property[$majortype]['type'];
+					$multiples = @ $this->property[$majortype]["$mode"]['multiples'];
+					$do_to_text = @ $this->property[$majortype]['to_text'];
+					}
+				elseif (substr($majortype, 0, 2) == 'x_') {
 						$state = 'optional';
 						$type = 'xtype';
 						$multiples = True;
 						$do_to_test = True;
-					}
-					else
-					{
+				} else {
 						$state = '';
 					}
-				}
-				else
-				{
+			} else {
 					$state = 'required';
 				}
 
-				if($majortype == 'duration')
-				{
+			if ($majortype == 'duration') {
 					// Unset dur var
-					unset($dur);
+				unset ($dur);
 
 					// Split DURATION
-					list($_f_['day_raw'], $_f_['time_raw']) = split('T', substr($value, 1, strlen($value)-1));
+				list ($_f_['day_raw'], $_f_['time_raw']) = split('T', substr($value, 1, strlen($value) - 1));
 
 					/* Datecode */
-					if(isset($_f_['day_raw']) OR $_f_['day_raw'])
-					{
+				if (isset ($_f_['day_raw']) OR $_f_['day_raw']) {
 						// Days
-//						if(ereg('D', $_f_['day_raw']))
-						if(strstr($_f_['day_raw'],'D'))
-						{
+					//						if(ereg('D', $_f_['day_raw']))
+					if (strstr($_f_['day_raw'], 'D')) {
 							$dur['days'] = eregi_replace("([0-9]+)D(.*)", "\\1", $_f_['day_raw']);
 						}
 
 						// Weeks
-//						if(ereg("W", $_f_["day_raw"]))
-						if(strstr($_f_['day_raw'],'W'))
-						{
+					//						if(ereg("W", $_f_["day_raw"]))
+					if (strstr($_f_['day_raw'], 'W')) {
 							$dur['weeks'] = eregi_replace("([^|.*]+D)?([0-9]+)W", "\\2", $_f_['day_raw']);
 						}
@@ -2644,10 +2394,8 @@
 
 					/* Timecode */
-					if(isset($_f_['time_raw']) OR $_f_['time_raw'])
-					{
+				if (isset ($_f_['time_raw']) OR $_f_['time_raw']) {
 						// Hours
-//						if(ereg("H", $_f_["time_raw"]))
-						if(strstr($_f_['time_raw'],'H'))
-						{
+					//						if(ereg("H", $_f_["time_raw"]))
+					if (strstr($_f_['time_raw'], 'H')) {
 							$dur['hours'] = eregi_replace("([0-9]+)H(.*)", "\\1", $_f_['time_raw']);
 						}
@@ -2655,7 +2403,6 @@
 						// Minutes
 						/* If you find better, contact me very quickly :) */
-//						if(ereg("M", $_f_["time_raw"]))
-						if(strstr($_f_['time_raw'],'M'))
-						{
+					//						if(ereg("M", $_f_["time_raw"]))
+					if (strstr($_f_['time_raw'], 'M')) {
 							$dur['minutes'] = eregi_replace("([^|.*]+H)?([0-9]+)M(.*)", "\\2", $_f_['time_raw']);
 						}
@@ -2663,12 +2410,11 @@
 						// Seconds
 						/* Same comment :) */
-//						if(ereg("S", $_f_["time_raw"]) )
-						if(strstr($_f_['time_raw'],'S'))
-						{
+					//						if(ereg("S", $_f_["time_raw"]) )
+					if (strstr($_f_['time_raw'], 'S')) {
 							$dur['seconds'] = eregi_replace("([^|.*]+M)?([0-9]+)S(.*)", "\\2", $_f_['time_raw']);
 						}
 					}
 
-					$dur['raw'] = Array(
+				$dur['raw'] = Array (
 						'timecode' => $_f_['time_raw'],
 						'datecode' => $_f_['day_raw'],
@@ -2679,97 +2425,87 @@
 				}
 
-				if($majortype == 'begin')
-				{
+			if ($majortype == 'begin') {
 					$tmode = $mode;
 					$mode = strtolower($value);
-					switch(strtolower($value))
-					{
-						case 'daylight':
-						case 'standard':
-							$t_event = Array();
+				switch (strtolower($value)) {
+					case 'daylight' :
+					case 'standard' :
+						$t_event = Array ();
 							$t_event = $event;
-							$event = Array();
+						$event = Array ();
 							break;
-						case 'valarm':
-							if($tmode == 'vevent' || $tmode == 'vtodo')
-							{
+					case 'valarm' :
+						if ($tmode == 'vevent' || $tmode == 'vtodo') {
 								$t_event = $event;
-								unset($event);
-								$event = Array();
-							}
-							else
-							{
+							unset ($event);
+							$event = Array ();
+						} else {
 								$mode = $tmode;
 							}
 							break;
-						case 'vcalendar':
+					case 'vcalendar' :
 							$ical = $this->new_ical();
 							break;
-						case 'vevent':
-						case 'vfreebusy':
-						case 'vjournal':
-						case 'vtimezone':
-						case 'vtodo':
-							$event = Array();
+					case 'vevent' :
+					case 'vfreebusy' :
+					case 'vjournal' :
+					case 'vtimezone' :
+					case 'vtodo' :
+						$event = Array ();
 							break;
 					}
 					$event['type'] = strtolower($value);
 				}
-				elseif($majortype == 'end')
-				{
+			elseif ($majortype == 'end') {
 					$mode = 'none';
-					switch(strtolower($value))
-					{
-						case 'daylight':
-						case 'standard':
+				switch (strtolower($value)) {
+					case 'daylight' :
+					case 'standard' :
 							$tzdata[] = $event;
-							unset($event);
+						unset ($event);
 							$event = $t_event;
-							unset($t_event);
+						unset ($t_event);
 							$mode = 'vtimezone';
 							break;
-						case 'valarm':
+					case 'valarm' :
 							$alarm[] = $event;
-							unset($event);
+						unset ($event);
 							$event = $t_event;
-							unset($t_event);
+						unset ($t_event);
 							$mode = $tmode;
 							break;
-						case 'vevent':
-							if(!empty($alarm))
-							{
+					case 'vevent' :
+						if (!empty ($alarm)) {
 								$event['alarm'] = $alarm;
-								unset($alarm);
+							unset ($alarm);
 							}
 							$this->event[] = $event;
-							unset($event);
+						unset ($event);
 							break;
-						case 'vfreebusy':
+					case 'vfreebusy' :
 							$this->freebusy[] = $event;
-							unset($event);
+						unset ($event);
 							break;
-						case 'vjournal':
+					case 'vjournal' :
 							$this->journal[] = $event;
-							unset($event);
+						unset ($event);
 							break;
-						case 'vtimezone':
-							if(!empty($tzdata))
-							{
+					case 'vtimezone' :
+						if (!empty ($tzdata)) {
 								$event['tzdata'] = $tzdata;
-								unset($tzdata);
+							unset ($tzdata);
 							}
 							$this->timezone[] = $event;
-							unset($event);
+						unset ($event);
 							break;
-						case 'vtodo':
-							if(!empty($alarm))
-							{
+					case 'vtodo' :
+						if (!empty ($alarm)) {
 								$event['alarm'] = $alarm;
-								unset($alarm);
+							unset ($alarm);
 							}
 							$this->todo[] = $event['alarm'];
-							unset($event);
+						unset ($event);
 							break;
-						case 'vcalendar':
+					case 'vcalendar' :
 							$this->ical = $ical;
 							$this->ical['event'] = $this->event;
@@ -2781,65 +2517,54 @@
 					}
 				}
-				elseif($majortype == 'prodid' || $majortype == 'version' || $majortype == 'method' || $majortype == 'calscale')
-				{
-					$this->parse_parameters($ical,$majortype,$this->from_text($value));
-				}
-				elseif($state == 'optional' || $state == 'required')
-				{
+			elseif ($majortype == 'prodid' || $majortype == 'version' || $majortype == 'method' || $majortype == 'calscale') {
+				$this->parse_parameters($ical, $majortype, $this->from_text($value));
+				}
+			elseif ($state == 'optional' || $state == 'required') {
 					//$this->debug('Mode : '.$mode.' Majortype : '.$majortype . ' Type : '.$type);
-					if($do_to_text)
-					{
+				if ($do_to_text) {
 						$value = $this->from_text($value);
 					}
-					switch($type)
-					{
-						case 'text':
-							$this->parse_parameters($event,$majortype,$value);
-							break;
-						case 'recur':
-						case 'date-time':
-						case 'cal-address':
-							$this->parse_value($event,$majortype,$value,$mode);
-							break;
-						case 'integer':
-							if($multiples)
-							{
-								$event[$majortype][] = (int)$value;
-							}
-							else
-							{
-								$this->set_var($event,$majortype,(int)$value);
-							}
-							break;
-						case 'float':
-							$event->$majortype = new class_geo;
-							$this->parse_geo($event->$majortype,$value);
-							break;
-						case 'utc-offset':
-							$this->set_var($event,$majortype,(int)$value);
-							break;
-						case 'uri':
-							$new_var = Array();
-							$this->parse_parameters($new_var,$majortype,$value);
-							if($multiples)
-							{
-								switch($mode)
-								{
-									case 'valarm':
+				switch ($type) {
+					case 'text' :
+						$this->parse_parameters($event, $majortype, $value);
+						break;
+					case 'recur' :
+					case 'date-time' :
+					case 'cal-address' :
+						$this->parse_value($event, $majortype, $value, $mode);
+						break;
+					case 'integer' :
+						if ($multiples) {
+							$event[$majortype][] = (int) $value;
+						} else {
+							$this->set_var($event, $majortype, (int) $value);
+						}
+						break;
+					case 'float' :
+						$event-> $majortype = new class_geo;
+						$this->parse_geo($event-> $majortype, $value);
+						break;
+					case 'utc-offset' :
+						$this->set_var($event, $majortype, (int) $value);
+						break;
+					case 'uri' :
+						$new_var = Array ();
+						$this->parse_parameters($new_var, $majortype, $value);
+						if ($multiples) {
+							switch ($mode) {
+								case 'valarm' :
 										$alarm['attach'][] = $new_var;
 										break;
-									default:
+								default :
 										$event[$majortype][] = $new_var;
 										break;
 								}
-							}
-							else
-							{
+						} else {
 								$event[$majortype] = $new_var;
 							}
-							unset($new_var);
+						unset ($new_var);
 							break;
-						case 'xtype':
-							$this->parse_xtype($event,$majortype,$value);
+					case 'xtype' :
+						$this->parse_xtype($event, $majortype, $value);
 							break;
 					}
@@ -2850,22 +2575,19 @@
 		}
 
-
-		function switch_to_phpgw_status($partstat)
-		{
-			switch($partstat)
-			{
-				case 0:
+	function switch_to_phpgw_status($partstat) {
+		switch ($partstat) {
+			case 0 :
 					return 'U';
 					break;
-				case 1:
+			case 1 :
 					return 'A';
 					break;
-				case 2:
+			case 2 :
 					return 'R';
 					break;
-				case 3:
+			case 3 :
 					return 'T';
 					break;
-				default:
+			default :
 					return 'U';
 					break;
@@ -2873,18 +2595,16 @@
 		}
 
-		function switch_phpgw_status($status)
-		{
-			switch($status)
-			{
-				case 'U':
+	function switch_phpgw_status($status) {
+		switch ($status) {
+			case 'U' :
 					return 0;
 					break;
-				case 'A':
+			case 'A' :
 					return 1;
 					break;
-				case 'R':
+			case 'R' :
 					return 2;
 					break;
-				case 'T':
+			case 'T' :
 					return 3;
 					break;
@@ -2892,116 +2612,122 @@
 		}
 
-		function is_owner($part_record)
-		{
-			if(($part_record['user'].'@'.$part_record['host'] == $GLOBALS['phpgw_info']['user']['preferences']['email']['address']) ||
-				($part_record['cn'] == $GLOBALS['phpgw_info']['user']['account_lid']))
-			{
+	function is_owner($part_record) {
+		if (($part_record['user'] . '@' . $part_record['host'] == $GLOBALS['phpgw_info']['user']['preferences']['email']['address']) || ($part_record['cn'] == $GLOBALS['phpgw_info']['user']['account_lid']) ||
+			($part_record['mailto']['user'] == $GLOBALS['phpgw_info']['user']['account_lid'])) {
 				return True;
-			}
-			else
-			{
+		} else {
 				return False;
 			}
 		}
 
-		function check_owner(&$event,$ical,$so_event)
-		{
-			if(!isset($event['participant'][$GLOBALS['phpgw_info']['user']['account_id']]))
-			{
-				if(isset($ical['organizer']))
-				{
-					if($this->is_owner($ical['organizer']))
-					{
-						$so_event->add_attribute('owner',$GLOBALS['phpgw_info']['user']['account_id']);
-						$so_event->add_attribute('participants',$this->switch_to_phpgw_status($ical['organizer']['partstat']),$GLOBALS['phpgw_info']['user']['account_id']);
-					}
-				}
-				elseif(isset($ical['attendee']))
-				{
+	function check_owner(& $event, $ical, $so_event) {
+		if (!isset ($event['participant'][$GLOBALS['phpgw_info']['user']['account_id']])) {
+			if (isset ($ical['organizer'])) {
+				if ($this->is_owner($ical['organizer'])) {
+					$so_event->add_attribute('owner', $GLOBALS['phpgw_info']['user']['account_id']);
+					$so_event->add_attribute('participants', $this->switch_to_phpgw_status($ical['organizer']['partstat']), $GLOBALS['phpgw_info']['user']['account_id']);
+					}
+				}
+			elseif (isset ($ical['attendee'])) {
 					$attendee_count = count($ical['attendee']);
 
-					for($j=0;$j<$attendee_count;$j++)
-					{
-						if($this->is_owner($ical['attendee'][$j]))
-						{
-							$so_event->add_attribute('participants',$this->switch_to_phpgw_status($ical['attendee'][$j]['partstat']),(int)$GLOBALS['phpgw_info']['user']['account_id']);
-						}
-					}
-				}
-				else
-				{
-					$so_event->add_attribute('owner',$GLOBALS['phpgw_info']['user']['account_id']);
-					$so_event->add_attribute('participants','A',$GLOBALS['phpgw_info']['user']['account_id']);
-				}
-			}
-		}
-
-		function import_file()
-		{
-			if($_FILES['uploadedfile']['tmp_name'] == 'none' || $_FILES['uploadedfile']['tmp_name'] == '')
-			{
-				Header('Location: ' . $GLOBALS['phpgw']->link('/index.php',
-						Array(
+				for ($j = 0; $j < $attendee_count; $j++) {
+					if ($this->is_owner($ical['attendee'][$j])) {
+						$so_event->add_attribute('participants', $this->switch_to_phpgw_status($ical['attendee'][$j]['partstat']), (int) $GLOBALS['phpgw_info']['user']['account_id']);
+						}
+					}
+			} else {
+				$so_event->add_attribute('owner', $GLOBALS['phpgw_info']['user']['account_id']);
+				$so_event->add_attribute('participants', 'A', $GLOBALS['phpgw_info']['user']['account_id']);
+				}
+			}
+		}
+
+	function import_file() {
+		if ($_FILES['uploadedfile']['tmp_name'] == 'none' || $_FILES['uploadedfile']['tmp_name'] == '') {
+			Header('Location: ' . $GLOBALS['phpgw']->link('/index.php', Array (
 							'menuaction'	=> 'calendar.uiicalendar.import',
 							'action'	=> 'GetFile'
-						)
-					)
-				);
+			)));
 				$GLOBALS['phpwg']->common->phpgw_exit();
 			}
 			$uploaddir = $GLOBALS['phpgw_info']['server']['temp_dir'] . SEP;
 
-			srand((double)microtime()*1000000);
-			$random_number = rand(100000000,999999999);
-			$newfilename = md5($_FILES['uploadedfile']['tmp_name'].", ".$uploadedfile_name.", "
-				. time() . getenv("REMOTE_ADDR") . $random_number );
+		srand((double) microtime() * 1000000);
+		$random_number = rand(100000000, 999999999);
+		$newfilename = md5($_FILES['uploadedfile']['tmp_name'] . ", " . $uploadedfile_name . ", " . time() . getenv("REMOTE_ADDR") . $random_number);
 
 			$filename = $uploaddir . $newfilename;
 
 			move_uploaded_file($_FILES['uploadedfile']['tmp_name'], $filename);
-//			$ftp = fopen($uploaddir . $newfilename . '.info','wb');
-//			fputs($ftp,$uploadedfile_type."\n".$uploadedfile_name."\n");
-//			fclose($ftp);
+		//			$ftp = fopen($uploaddir . $newfilename . '.info','wb');
+		//			fputs($ftp,$uploadedfile_type."\n".$uploadedfile_name."\n");
+		//			fclose($ftp);
 			return $filename;
 		}
 
-		function import($mime_msg='', $from_ajax = false)
-		{
-			if($_FILES['uploadedfile']['tmp_name'] != 'none' && $_FILES['uploadedfile']['tmp_name'] != '')
-			{
+	function safeBitCheck($number, $comparison) {
+		$binNumber = base_convert($number, 10, 2);
+		$binComparison = strrev(base_convert($comparison, 10, 2));
+		$str = strlen($binNumber);
+
+		if (($str <= strlen($binComparison)) && ($binComparison {
+			$str -1 }
+		=== "1"))
+		return '1';
+else
+	return '0';
+}
+
+function import($mime_msg = '', $from_ajax = false, $importAccount = false) {
+	/*
+	 * Caso seja uma importação para conta compartilhada carrega as acls do usuario
+	 */
+	if ($importAccount != false) {
+		$colunas = array (
+			'acl_appname',
+			'acl_location',
+			'acl_account',
+			'acl_rights'
+		);
+		$where = array (
+			'acl_appname' => 'calendar',
+			'acl_account' => $importAccount['uidnumber'],
+			'acl_location' => $GLOBALS['phpgw_info']['user']['account_id']
+		);
+		$db = $GLOBALS['phpgw']->db;
+		$db->select('phpgw_acl', $colunas, $where, null, null);
+		$row = $db->row(true);
+
+		if (!$this->safeBitCheck(2, $row['acl_rights'])) //Se o usuario não tem permisão de adicionar eventos
+			return 'You do not have permission to add events';
+	}
+
+	if ($_FILES['uploadedfile']['tmp_name'] != 'none' && $_FILES['uploadedfile']['tmp_name'] != '') {
 				$filename = $this->import_file();
-				$fp=fopen($filename,'rt');
-				$mime_msg = explode("\n",fread($fp, filesize($filename)));
+		$fp = fopen($filename, 'rt');
+		$mime_msg = explode("\n", fread($fp, filesize($filename)));
 				fclose($fp);
 				unlink($filename);
 			}
-			elseif(!$mime_msg)
-			{
-				Header('Location: ' . $GLOBALS['phpgw']->link('/index.php',
-						Array(
+	elseif (!$mime_msg) {
+		Header('Location: ' . $GLOBALS['phpgw']->link('/index.php', Array (
 							'menuaction'	=> 'calendar.uiicalendar.import',
 							'action'	=> 'GetFile'
-						)
-					)
-				);
+		)));
 				$GLOBALS['phpwg']->common->phpgw_exit();
 			}
 
-			if(!is_object($GLOBALS['uicalendar']))
-			{
-				$so_event = createobject('calendar.socalendar',
-					Array(
+	if (!is_object($GLOBALS['uicalendar'])) {
+		$so_event = createobject('calendar.socalendar', Array (
 						'owner'	=> 0,
 						'filter'	=> '',
 						'category'	=> ''
-					)
-				);
-			}
-			else
-			{
+		));
+	} else {
 				$so_event = $GLOBALS['uicalendar']->bo->so;
 			}
 
-			$datetime_vars = Array(
+	$datetime_vars = Array (
 				'start'	=> 'dtstart',
 				'end'	=> 'dtend',
@@ -3010,5 +2736,5 @@
 			);
 
-			$date_array = Array(
+	$date_array = Array (
 				'Y'	=> 'year',
 				'm'	=> 'month',
